| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | ## |
| 4 | # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U. |
| 5 | # This file is part of openmano |
| 6 | # All Rights Reserved. |
| 7 | # |
| 8 | # Licensed under the Apache License, Version 2.0 (the "License"); you may |
| 9 | # not use this file except in compliance with the License. You may obtain |
| 10 | # a copy of the License at |
| 11 | # |
| 12 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 13 | # |
| 14 | # Unless required by applicable law or agreed to in writing, software |
| 15 | # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT |
| 16 | # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the |
| 17 | # License for the specific language governing permissions and limitations |
| 18 | # under the License. |
| 19 | # |
| 20 | # For those usages not covered by the Apache License, Version 2.0 please |
| 21 | # contact with: nfvlabs@tid.es |
| 22 | ## |
| 23 | |
| 24 | #ONLY TESTED for Ubuntu 16.04 |
| 25 | #it configures openmano to run as a service |
| 26 | |
| 27 | function usage(){ |
| 28 | echo -e "usage: sudo $0 [OPTIONS]" |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 29 | echo -e "Configures openmano to run as a service at /opt" |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 30 | echo -e " OPTIONS" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 31 | echo -e " -u USER_OWNER user owner of the service, 'root' by default" |
| 32 | echo -e " -f PATH path where openmano source is located. If missing it is downloaded from git" |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 33 | echo -e " -d --delete: if -f is provided, delete this path after copying to /opt" |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 34 | echo -e " -h: show this help" |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 35 | echo -e " --uninstall: remove created service and files" |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 36 | } |
| 37 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 38 | function uninstall(){ |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 39 | echo "systemctl disable openmano.service " && systemctl disable openmano.service 2>/dev/null || echo " Already done" |
| 40 | echo "service openmano stop " && service openmano stop 2>/dev/null || echo " Already done" |
| 41 | for file in /opt/openmano /etc/default/openmanod.cfg /var/log/openmano /etc/systemd/system/openmano.service /usr/bin/openmano /usr/sbin/service-openmano /usr/bin/openmano-report |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 42 | do |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 43 | echo rm $file |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 44 | rm -rf $file || ! echo "Can not delete '$file'. Needed root privileges?" >&2 || exit 1 |
| 45 | done |
| 46 | echo "Done" |
| 47 | } |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 48 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 49 | GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git |
| 50 | USER_OWNER="root" |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 51 | QUIET_MODE="" |
| 52 | FILE="" |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 53 | DELETE="" |
| 54 | while getopts ":u:f:hdq-:" o; do |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 55 | case "${o}" in |
| 56 | u) |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 57 | export USER_OWNER="$OPTARG" |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 58 | ;; |
| 59 | f) |
| 60 | export FILE="$OPTARG" |
| 61 | ;; |
| 62 | q) |
| 63 | export QUIET_MODE=yes |
| 64 | ;; |
| 65 | h) |
| 66 | usage && exit 0 |
| 67 | ;; |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 68 | d) |
| 69 | DELETE=y |
| 70 | ;; |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 71 | -) |
| 72 | [ "${OPTARG}" == "help" ] && usage && exit 0 |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 73 | [ "${OPTARG}" == "uninstall" ] && uninstall && exit 0 |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 74 | [ "${OPTARG}" == "delete" ] && DELETE=y && continue |
| 75 | echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2 |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 76 | exit 1 |
| 77 | ;; |
| 78 | \?) |
| 79 | echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2 |
| 80 | exit 1 |
| 81 | ;; |
| 82 | :) |
| 83 | echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2 |
| 84 | exit 1 |
| 85 | ;; |
| 86 | *) |
| 87 | usage >&2 |
| 88 | exit -1 |
| 89 | ;; |
| 90 | esac |
| 91 | done |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 92 | BAD_PATH_ERROR="Path '$FILE' does not contain a valid openmano distribution" |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 93 | |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 94 | #check root privileges |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 95 | [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1 |
| 96 | |
| 97 | #Discover Linux distribution |
| 98 | #try redhat type |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 99 | if [[ -f /etc/redhat-release ]] |
| 100 | then |
| 101 | _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1) |
| 102 | else |
| 103 | #if not assuming ubuntu type |
| 104 | _DISTRO=$(lsb_release -is 2>/dev/null) |
| 105 | fi |
| 106 | if [[ "$_DISTRO" == "Ubuntu" ]] |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 107 | then |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 108 | _RELEASE=$(lsb_release -rs) |
| 109 | if [[ ${_RELEASE%%.*} != 16 ]] |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 110 | then |
| 111 | echo "Only tested in Ubuntu Server 16.04" >&2 && exit 1 |
| 112 | fi |
| 113 | else |
| 114 | echo "Only tested in Ubuntu Server 16.04" >&2 && exit 1 |
| 115 | fi |
| 116 | |
| 117 | |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 118 | if [[ -z "$FILE" ]] |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 119 | then |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 120 | FILE=__temp__${RANDOM} |
| 121 | git clone $GIT_URL $FILE || ! echo "Cannot get openmano source code from $GIT_URL" >&2 || exit 1 |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 122 | DELETE=y |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 123 | else |
| 124 | [[ -d "$FILE" ]] || ! echo $BAD_PATH_ERROR >&2 || exit 1 |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 125 | fi |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 126 | |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 127 | #make idempotent |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 128 | uninstall |
| 129 | #copy files |
| 130 | cp -r "$FILE" /opt/openmano || ! echo $BAD_PATH_ERROR >&2 || exit 1 |
| tierno | c50b435 | 2016-09-14 15:54:54 +0200 | [diff] [blame] | 131 | mkdir -p /opt/openmano/logs |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 132 | #makes links |
| 133 | ln -s -v /opt/openmano/openmanod.cfg /etc/default/openmanod.cfg || echo "warning cannot create link '/etc/default/openmanod.cfg'" |
| 134 | ln -s -v /opt/openmano/logs /var/log/openmano || echo "warning cannot create link '/var/log/openmano'" |
| 135 | ln -s -v /opt/openmano/openmano /usr/bin/openmano |
| 136 | ln -s -v /opt/openmano/scripts/service-openmano.sh /usr/sbin/service-openmano |
| 137 | ln -s -v /opt/openmano/scripts/openmano-report.sh /usr/bin/openmano-report |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 138 | |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 139 | chown -R $SUDO_USER /opt/openmano |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 140 | |
| garciadeblas | 89b3d84 | 2016-09-19 15:18:33 +0200 | [diff] [blame] | 141 | mkdir -p /etc/systemd/system/ |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 142 | cat > /etc/systemd/system/openmano.service << EOF |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 143 | [Unit] |
| 144 | Description=openmano server |
| 145 | |
| 146 | [Service] |
| tierno | 45a5285 | 2016-08-26 14:39:42 +0200 | [diff] [blame] | 147 | User=${USER_OWNER} |
| 148 | ExecStart=/opt/openmano/openmanod.py -c /opt/openmano/openmanod.cfg --log-file=/opt/openmano/logs/openmano.log |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 149 | Restart=always |
| 150 | |
| 151 | [Install] |
| 152 | WantedBy=multi-user.target |
| 153 | EOF |
| 154 | |
| tierno | aa5832d | 2016-12-07 16:20:25 +0100 | [diff] [blame] | 155 | [[ -n $DELETE ]] && rm -rf ${FILE} |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 156 | |
| 157 | service openmano start |
| tierno | 2677765 | 2016-11-15 17:33:13 +0000 | [diff] [blame] | 158 | systemctl enable openmano.service |
| tierno | 205d102 | 2016-07-21 11:26:22 +0200 | [diff] [blame] | 159 | |
| 160 | echo Done |
| 161 | exit |